#ifndef __BridgeToTcpSpanner_h__
#define __BridgeToTcpSpanner_h__

#include "BridgeToTcp.h"
#include "StateGraphSpanner.h"

class BridgeToTcpToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new BridgeToTcp;
    }
};

class BridgeToTcpSpanner
{
public:
    void eventsForBridgeToTcp( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForBridgeToTcp( stateGraph._events );

        BridgeToTcpToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "bridgeToTcp";
    }
};

#endif // __BridgeToTcpSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
