#ifndef __HttpErrorHandlerSpanner_h__
#define __HttpErrorHandlerSpanner_h__

#include "HttpErrorHandler.h"
#include "StateGraphSpanner.h"

class HttpErrorHandlerToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new HttpErrorHandler;
    }
};

class HttpErrorHandlerSpanner
{
public:
    void eventsForHttpErrorHandler( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForHttpErrorHandler( stateGraph._events );

        HttpErrorHandlerToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "httpErrorHandler";
    }
};

#endif // __HttpErrorHandlerSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
