#ifndef __TcpAckSenderSpanner_h__
#define __TcpAckSenderSpanner_h__

#include "TcpAckSender.h"
#include "StateGraphSpanner.h"

class TcpAckSenderToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new TcpAckSender;
    }
};

class TcpAckSenderSpanner
{
public:
    void eventsForTcpAckSender( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();

        events.eraseByValue( IEvent::TCP_SEND_ACK );
        events.eraseByValue( IEvent::SEQUENCE_NUMBER_FOR_ACK_SENDER );

        HeapData serialized;

        TcpSegment push;
        push.header().setDestinationPort( ServerConfiguration::LISTENING_PORT );
        push.header().setPush();
        char buffer[] = "hello world";
        push._payload = ConstSimpleData( buffer, sizeof(buffer) );
        push.serialize( serialized );
        events.append( Event( IEvent::TCP_SEND_ACK, serialized ) );

        SequenceNumberPayload sequenceNumber( 1, 1 );
        events.append( Event( IEvent::SEQUENCE_NUMBER_FOR_ACK_SENDER, ConstSimpleData( &sequenceNumber, sizeof(sequenceNumber) ) ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForTcpAckSender( stateGraph._events );

        TcpAckSenderToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "tcpAckSender";
    }
};

#endif // __TcpAckSenderSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
