#ifndef __TcpFinHandlerSpanner_h__
#define __TcpFinHandlerSpanner_h__

#include "TcpFinHandler.h"
#include "StateGraphSpanner.h"

class TcpFinHandlerToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new TcpFinHandler;
    }
};

class TcpFinHandlerSpanner
{
public:
    void eventsForTcpFinHandler( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();

        events.eraseByValue( IEvent::TCP_FIN_REQUEST );
        events.eraseByValue( IEvent::SEQUENCE_NUMBER_FOR_FIN_HANDLER );

        HeapData serialized;

        TcpSegment fin;
        fin.header().setDestinationPort( ServerConfiguration::LISTENING_PORT );
        fin.header().setFin();
        fin.serialize( serialized );
        events.append( Event( IEvent::TCP_FIN_REQUEST, serialized ) );

        SequenceNumberPayload sequenceNumber( 1, 1 );
        events.append( Event( IEvent::SEQUENCE_NUMBER_FOR_FIN_HANDLER, ConstSimpleData( &sequenceNumber, sizeof(sequenceNumber) ) ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForTcpFinHandler( stateGraph._events );

        TcpFinHandlerToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "tcpFinHandler";
    }
};

#endif // __TcpFinHandlerSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
