#ifndef __TcpPushHandlerSpanner_h__
#define __TcpPushHandlerSpanner_h__

#include "TcpPushHandler.h"
#include "StateGraphSpanner.h"

class TcpPushHandlerToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new TcpPushHandler;
    }
};

class TcpPushHandlerSpanner
{
public:
    void eventsForTcpPushHandler( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();

        events.eraseByValue( IEvent::TCP_PUSH_REQUEST );

        HeapData serialized;

        TcpSegment push;
        push.header().setDestinationPort( ServerConfiguration::LISTENING_PORT );
        push.header().setPush();
        char buffer[] = "hello";
        push._payload = ConstSimpleData( buffer, sizeof(buffer) );
        push.serialize( serialized );

        events.append( Event( IEvent::TCP_PUSH_REQUEST, serialized ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForTcpPushHandler( stateGraph._events );

        TcpPushHandlerToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "tcpPushHandler";
    }
};

#endif // __TcpPushHandlerSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
