#ifndef __TcpSynHandlerSpanner_h__
#define __TcpSynHandlerSpanner_h__

#include "TcpSynHandler.h"
#include "StateGraphSpanner.h"

class TcpSynHandlerToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new TcpSynHandler;
    }
};

class TcpSynHandlerSpanner
{
public:
    void eventsForTcpSynHandler( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();

        events.eraseByValue( IEvent::TCP_SYN_REQUEST );
        events.eraseByValue( IEvent::SEQUENCE_NUMBER_FOR_SYN_HANDLER );

        HeapData serialized;

        TcpSegment syn;
        syn.header().setDestinationPort( ServerConfiguration::LISTENING_PORT );
        syn.header().setSyn();
        syn.serialize( serialized );
        events.append( Event( IEvent::TCP_SYN_REQUEST, serialized ) );

        SequenceNumberPayload sequenceNumber( 1, 1 );
        events.append( Event( IEvent::SEQUENCE_NUMBER_FOR_SYN_HANDLER, ConstSimpleData( &sequenceNumber, sizeof(sequenceNumber) ) ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForTcpSynHandler( stateGraph._events );

        TcpSynHandlerToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "tcpSynHandler";
    }
};

#endif // __TcpSynHandlerSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
