#ifndef __SynBeforeFin_h__
#define __SynBeforeFin_h__

#include "NFA.h"

class SynBeforeFin
{
public:
    static NFA getNfa()
    {
        NFA safetyProperty;

        /// Alphabet: 64 letters total

        // 1 Empty Set
        safetyProperty.addLetter( "Phi" );

        // 6 Singletons
        safetyProperty.addLetter( "MsgToHttp" );
        safetyProperty.addLetter( "MsgToTcp" );
        safetyProperty.addLetter( "SendFinAck" );
        safetyProperty.addLetter( "SendSynAck" );
        safetyProperty.addLetter( "SeqMasterReplying" );
        safetyProperty.addLetter( "TcpDispatching" );

        // 15 Pairs
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck" );
        safetyProperty.addLetter( "MsgToHttp;SendSynAck" );
        safetyProperty.addLetter( "MsgToHttp;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck" );
        safetyProperty.addLetter( "MsgToTcp;SendSynAck" );
        safetyProperty.addLetter( "MsgToTcp;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToTcp;TcpDispatching" );
        safetyProperty.addLetter( "SendFinAck;SendSynAck" );
        safetyProperty.addLetter( "SendFinAck;SeqMasterReplying" );
        safetyProperty.addLetter( "SendFinAck;TcpDispatching" );
        safetyProperty.addLetter( "SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "SeqMasterReplying;TcpDispatching" );

        // 20 Triplets
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendSynAck" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;SendSynAck" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;SendSynAck" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToTcp;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "SendFinAck;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "SendFinAck;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "SendFinAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "SendSynAck;SeqMasterReplying;TcpDispatching" );

        // 15 Quadruples
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SendSynAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching" );

        // 6 Quintuples
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching" );
        safetyProperty.addLetter( "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching" );

        // 1 Sextuple
        safetyProperty.addLetter( "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching" );

        /// States

        safetyProperty.addState( "q0" );
        safetyProperty.addState( "q1" );
        safetyProperty.addState( "q2" );
        safetyProperty.addState( "q3" );
        safetyProperty.addState( "q4" );

        safetyProperty.setInitialState( "q0" );

        safetyProperty.markAsAccepting( "q4" ); // Reaching this state constitutes a violation of the property

        /// Edges: 64 letters X 4 states

        // State q0:
        //    SendFinAck sends us to the bad state
        //    SendSynAck (without SendFinAck) sends us to state q1
        //    Rest are loops

        safetyProperty.addEdge( NFA::Edge( "q0", "Phi", "q0" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "TcpDispatching", "q0" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SeqMasterReplying;TcpDispatching", "q0" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SeqMasterReplying;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SeqMasterReplying;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SeqMasterReplying;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q0", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );

        // State q1:
        //    SendFinAck with SendSynAck sends us to the bad state
        //    Just SendSynAck: self loop
        //    Just SendFinAck: state q3
        //    Rest: state q2

        safetyProperty.addEdge( NFA::Edge( "q1", "Phi", "q2" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "TcpDispatching", "q2" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SeqMasterReplying;TcpDispatching", "q2" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SeqMasterReplying;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SeqMasterReplying;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SeqMasterReplying;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q1", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );

        // State q2:
        //    SendFinAck with SendSynAck sends us to the bad state
        //    Just SendSynAck: state q2
        //    Just SendFinAck: state q3
        //    Rest: self loops

        safetyProperty.addEdge( NFA::Edge( "q2", "Phi", "q2" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "TcpDispatching", "q2" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SeqMasterReplying;TcpDispatching", "q2" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SeqMasterReplying", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SeqMasterReplying;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SeqMasterReplying;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SeqMasterReplying;TcpDispatching", "q2" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q2", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );

        // State q3:
        //    SendFinAck with SendSynAck sends us to the bad state
        //    Just SendSynAck: state q1
        //    Just SendFinAck: self loops
        //    Rest: state q0

        safetyProperty.addEdge( NFA::Edge( "q3", "Phi", "q0" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "TcpDispatching", "q0" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SeqMasterReplying;TcpDispatching", "q0" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendSynAck", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SeqMasterReplying", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SeqMasterReplying;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SeqMasterReplying;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendSynAck;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SeqMasterReplying;TcpDispatching", "q0" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q3" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q1" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q3", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );

        // State q4:
        //    The bad state
        //    All are self loops

        safetyProperty.addEdge( NFA::Edge( "q4", "Phi", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );
        //
        safetyProperty.addEdge( NFA::Edge( "q4", "MsgToHttp;MsgToTcp;SendFinAck;SendSynAck;SeqMasterReplying;TcpDispatching", "q4" ) );

        return safetyProperty;
    }
};

#endif // __SynBeforeFin_h__

//
// Local Variables:
// compile-command: "make -C ../../.. "
// tags-file-name: "../../../TAGS"
// c-basic-offset: 4
// End:
//
